﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using LibUsbDotNet.Usb;
using LibUsbDotNet.Usb.Main;

namespace my__usb_1
{
    public partial class Form1 : Form
    {

        UsbDevice myDevice;
        UsbEndpointReader myEpReader;
        
        public Form1()
        {
            InitializeComponent();
        }

        private delegate void OnDataReceivedDelegate(object sender, DataReceivedArgs e);

        void myEp_DataReceived(object sender, DataReceivedArgs e)
        {
            Invoke(new OnDataReceivedDelegate(OnDataReceived), new Object[] { sender, e });
        }

        void OnDataReceived(object sender, DataReceivedArgs e)
        {
            showBytes(e.Buffer, (uint)e.Count);
        }


        void closeDevice()
            {
                if (myDevice != null)
                {
                    
                    if (myEpReader != null)
                    {
                        myEpReader.DataReceivedEnabled = false;
                        myEpReader.DataReceived -= myEp_DataReceived;
                        myEpReader.Dispose();
                        myEpReader = null;
                    }

                    myDevice.ReleaseInterface(0);
                    myDevice.SetConfiguration(0);

                    myDevice.Close();
                    myDevice = null;
                }
                
            }

        private void showBytes(byte[] readBuffer, uint uiTransmitted)
        {
            
                string s = "";
                for (int i = 0; i < uiTransmitted; i++)
                {
                    s += readBuffer[i].ToString("X2") + " ";
                }
                textReceived.Text += s;
            
            
        }



        private void openButton_Click(object sender, EventArgs e)
        {
            
                        
            UsbDeviceList myList = UsbGlobals.DeviceList;

            closeDevice();
           
            foreach (UsbDevice bus in myList)
            {
                if (bus.Info.IdVendor == 0x16c0 && bus.Info.IdProduct == 0x5dc)
                {
                    myDevice = bus;
                    myDevice.Open();

                    break;
                }
            }
            if (myDevice == null) labelStatus.Text = "please connect device";
            else if (myDevice.IsOpen)
            {
                labelStatus.Text = "connected";

                Debug.Assert(myDevice.SetConfiguration(1) == 0);
                Debug.Assert(myDevice.ClaimInterface(0) == 0);

               // myEpReader = myDevice.OpenBulkEndpointReader(ReadEndpoints.Ep01);
                myEpReader = myDevice.OpenInterruptEndpointReader(ReadEndpoints.Ep01);
                myEpReader.DataReceivedEnabled = false;
                myEpReader.DataReceived += myEp_DataReceived;

                
            }
            else labelStatus.Text = "faild";
        }

        private void readButton_Click(object sender, EventArgs e)
        {
            byte[] readBuffer = new byte[64];

            int ret;
            ret = myEpReader.Read(readBuffer, 1000);
            if (ret >= 0)
            {
                labelStatus.Text = ret + " bytes read.";
                showBytes(readBuffer, (uint)ret);
            }
            else
                labelStatus.Text = "No data to read! ErrorCode:" + ret;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            closeDevice();
        }

        private void closeButton_Click(object sender, EventArgs e)
        {
            closeDevice();
            labelStatus.Text = "closed";
        }

        private void checkRead_CheckedChanged(object sender, EventArgs e)
        {
            if (myEpReader != null)
            {
                checkRead.Enabled = false;
                if (checkRead.Checked)
                {
                    myEpReader.DataReceivedEnabled = true;
                    readButton.Enabled = false;
                }
                else
                {
                    myEpReader.DataReceivedEnabled = false;
                    readButton.Enabled = true;
                }
                checkRead.Enabled = true;
            }
        }
    }
}
